/* gencode.c
   code generator som-c		2 Jan 2004
	improve clean, not gen when empty body  14 Mar 2004
	SQL where clause parser  		14 Feb 2016 (Valentine!)
*/

#include "compile.h"
//#include "icname.h"

#define		PRIVATE		static

#define head(e)		car(e)
#define tail(e) 	cdr(e)
#define arg1(e)		car(e)
#define arg2(e)		item2(e)
#define arg3(e)		item3(e)

int M[MAXMEM];
//extern int M[];

extern int CP;				/* current code pointer */

int currentf;		/* current function idx */
int fp;
/*
PRIVATE int atomeq(int e, int type, int value){
	return (car(e) == type) && (cdr(e) == value);
}
*/

PRIVATE void genatom2(int x){
	pratom(x);
	printf("\n");
}

void outline(char *s){
	printf("%s\n",s);
}

// e must be list  .. (list ex ex ...)
void outlist(int e){
	e = cdr(e);
	printf("(");
	while( cdr(e) != NIL ){
		pratom(car(e));
		printf(", ");
		e = cdr(e);
	}
	pratom(car(e));		// last item
	printf(")");
}

void genex(int x){
	int a, e;

	if( x == NIL ) return;
	if(isatom(x)){ genatom2(x); return; }

	a = car(x);			// (op ex .. )
	e = cdr(x);			// e = (ex .. )
	if(car(a) != OPER)
		seterror("genex: expect operator");
	switch(cdr(a)){
	case tkAND:
	case tkOR:
		outline("LB (");
		printf("logic ");
		pratom(a);
		printf("\n");
		genex(car(e));
		genex(item2(e));
		outline("RB )");
		break;
	case tkEQ:
	case tkNE:
	case tkGT:
	case tkGE:
	case tkLT:
	case tkLE:
	case tkIS:
	case tkLIKE:
	case tkNLIKE:
		printf("name ");
		genex(car(e));
		printf("op ");
		pratom(a);
		printf("\n");
		printf("value ");
		genex(item2(e));
		break;
	case tkIN:
	case tkNIN:
		printf("name ");
		genex(car(e));
		printf("op ");
		pratom(a);
		printf("\n");
		printf("value ");
		outlist(item2(e));
		printf("\n");
		break;
	case tkBETWEEN:
	case tkNBET:
		printf("name ");
		genex(car(e));
		printf("op ");
		pratom(a);
		printf("\n");
		printf("value ");
		pratom(item2(e));
		printf(" ");
		pratom(item3(e));
		printf("\n");
		break;

	default:
		seterror("unknown op\n");
	}
}
